## vis 0.4

=== Makefile ===
-include config.mk

REGEX_SRC ?= text-regex.c

SRC = array.c buffer.c libutf.c main.c map.c \
	sam.c text.c text-motions.c text-objects.c text-util.c \
	ui-terminal.c view.c vis.c vis-lua.c vis-modes.c vis-motions.c \
	vis-operators.c vis-registers.c vis-marks.c vis-prompt.c vis-text-objects.c $(REGEX_SRC)

ELF = vis vis-menu vis-digraph
EXECUTABLES = $(ELF) vis-clipboard vis-complete vis-open

MANUALS = $(EXECUTABLES:=.1)

DOCUMENTATION = LICENSE README.md

VERSION = v0.4

CONFIG_HELP ?= 1
CONFIG_CURSES ?= 1
CONFIG_LUA ?= 1
CONFIG_LPEG ?= 0
CONFIG_TRE ?= 0
CONFIG_ACL ?= 0
CONFIG_SELINUX ?= 0

CFLAGS_STD ?= -std=c99 -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700 -DNDEBUG
CFLAGS_STD += -DVERSION=\"${VERSION}\"
LDFLAGS_STD ?= -lc

CFLAGS_LIBC ?= -DHAVE_MEMRCHR=0

CFLAGS_VIS = $(CFLAGS_AUTO) $(CFLAGS_TERMKEY) $(CFLAGS_CURSES) $(CFLAGS_ACL) \
	$(CFLAGS_SELINUX) $(CFLAGS_TRE) $(CFLAGS_LUA) $(CFLAGS_LPEG) $(CFLAGS_STD) \
	$(CFLAGS_LIBC)

CFLAGS_VIS += -DVIS_PATH=\"${SHAREPREFIX}/vis\"
CFLAGS_VIS += -DCONFIG_HELP=${CONFIG_HELP}
CFLAGS_VIS += -DCONFIG_CURSES=${CONFIG_CURSES}
CFLAGS_VIS += -DCONFIG_LUA=${CONFIG_LUA}
CFLAGS_VIS += -DCONFIG_LPEG=${CONFIG_LPEG}
CFLAGS_VIS += -DCONFIG_TRE=${CONFIG_TRE}
CFLAGS_VIS += -DCONFIG_SELINUX=${CONFIG_SELINUX}
CFLAGS_VIS += -DCONFIG_ACL=${CONFIG_ACL}

LDFLAGS_VIS = $(LDFLAGS_AUTO) $(LDFLAGS_TERMKEY) $(LDFLAGS_CURSES) $(LDFLAGS_ACL) \
	$(LDFLAGS_SELINUX) $(LDFLAGS_TRE) $(LDFLAGS_LUA) $(LDFLAGS_LPEG) $(LDFLAGS_STD)

STRIP?=strip

all: $(ELF)

config.h:
	cp config.def.h config.h

config.mk:
	@touch $@

vis: config.h config.mk *.c *.h
	${CC} ${CFLAGS} ${CFLAGS_VIS} ${CFLAGS_EXTRA} ${SRC} ${LDFLAGS} ${LDFLAGS_VIS} -o $@

vis-menu: vis-menu.c
	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -o $@

vis-digraph: vis-digraph.c
	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -o $@

vis-single-payload.inc: $(EXECUTABLES) lua/*
	for e in $(ELF); do \
		${STRIP} "$$e"; \
	done
	echo '#ifndef VIS_SINGLE_PAYLOAD_H' > $@
	echo '#define VIS_SINGLE_PAYLOAD_H' >> $@
	echo 'static unsigned char vis_single_payload[] = {' >> $@
	tar --mtime='2014-07-15 01:23Z' --owner=0 --group=0 --numeric-owner --mode='a+rX-w' -c \
		$(EXECUTABLES) $$(find lua -name '*.lua' | LC_ALL=C sort) | xz -T 1 | \
		od -t x1 -A none -v | sed 's/\([0-9a-f]\+\)/0x\1,/g;$$s/,$$/ };/' >> $@
	echo '#endif' >> $@

vis-single: vis-single.c vis-single-payload.inc
	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -luntar -llzma -o $@
	${STRIP} $@

docker: clean
	docker rm -f vis || true
	docker build -t vis .
	docker run --rm -d --name vis vis tail -f /dev/null
	docker cp . vis:/tmp/vis
	docker exec vis sed -i '/^VERSION/c VERSION = $(VERSION)' Makefile
	docker exec vis ./configure CC='cc --static'
	docker exec vis make clean vis-single
	docker cp vis:/tmp/vis/vis-single vis
	docker kill vis

debug: clean
	@$(MAKE) CFLAGS_EXTRA='${CFLAGS_EXTRA} ${CFLAGS_DEBUG}'

profile: clean
	@$(MAKE) CFLAGS_AUTO='' LDFLAGS_AUTO='' CFLAGS_EXTRA='-pg -O2'

coverage: clean
	@$(MAKE) CFLAGS_EXTRA='--coverage'

test-update:
	git submodule init
	git submodule update --remote --rebase

test:
	[ -e test/Makefile ] || $(MAKE) test-update
	@$(MAKE) -C test

clean:
	@echo cleaning
	@rm -f $(ELF) vis-single vis-single-payload.inc vis-*.tar.gz *.gcov *.gcda *.gcno

dist: clean
	@echo creating dist tarball
	@git archive --prefix=vis-${VERSION}/ -o vis-${VERSION}.tar.gz HEAD

man:
	@for m in ${MANUALS}; do \
		echo "Generating $$m"; \
		sed -e "s/VERSION/${VERSION}/" "man/$$m" | mandoc -W warning -T utf8 -T xhtml -O man=%N.%S.html -O style=mandoc.css 1> "man/$$m.html" || true; \
	done

luadoc:
	@cd lua/doc && ldoc . && sed -e "s/RELEASE/${VERSION}/" -i index.html

luadoc-all:
	@cd lua/doc && ldoc -a . && sed -e "s/RELEASE/${VERSION}/" -i index.html

luacheck:
	@luacheck --config .luacheckrc lua test/lua | less -RFX

install: $(ELF)
	@echo stripping executable
	@for e in $(ELF); do \
		${STRIP} "$$e"; \
	done
	@echo installing executable files to ${DESTDIR}${PREFIX}/bin
	@mkdir -p ${DESTDIR}${PREFIX}/bin
	@for e in ${EXECUTABLES}; do \
		cp -f "$$e" ${DESTDIR}${PREFIX}/bin && \
		chmod 755 ${DESTDIR}${PREFIX}/bin/"$$e"; \
	done
	@test ${CONFIG_LUA} -eq 0 || { \
		echo installing support files to ${DESTDIR}${SHAREPREFIX}/vis; \
		mkdir -p ${DESTDIR}${SHAREPREFIX}/vis; \
		cp -r lua/* ${DESTDIR}${SHAREPREFIX}/vis; \
		rm -rf "${DESTDIR}${SHAREPREFIX}/vis/doc"; \
	}
	@echo installing documentation to ${DESTDIR}${DOCPREFIX}/vis
	@mkdir -p ${DESTDIR}${DOCPREFIX}/vis
	@for d in ${DOCUMENTATION}; do \
		cp "$$d" ${DESTDIR}${DOCPREFIX}/vis && \
		chmod 644 "${DESTDIR}${DOCPREFIX}/vis/$$d"; \
	done
	@echo installing manual pages to ${DESTDIR}${MANPREFIX}/man1
	@mkdir -p ${DESTDIR}${MANPREFIX}/man1
	@for m in ${MANUALS}; do \
		sed -e "s/VERSION/${VERSION}/" < "man/$$m" >  "${DESTDIR}${MANPREFIX}/man1/$$m" && \
		chmod 644 "${DESTDIR}${MANPREFIX}/man1/$$m"; \
	done

uninstall:
	@echo removing executable file from ${DESTDIR}${PREFIX}/bin
	@for e in ${EXECUTABLES}; do \
		rm -f ${DESTDIR}${PREFIX}/bin/"$$e"; \
	done
	@echo removing documentation from ${DESTDIR}${DOCPREFIX}/vis
	@for d in ${DOCUMENTATION}; do \
		rm -f ${DESTDIR}${DOCPREFIX}/vis/"$$d"; \
	done
	@echo removing manual pages from ${DESTDIR}${MANPREFIX}/man1
	@for m in ${MANUALS}; do \
		rm -f ${DESTDIR}${MANPREFIX}/man1/"$$m"; \
	done
	@echo removing support files from ${DESTDIR}${SHAREPREFIX}/vis
	@rm -rf ${DESTDIR}${SHAREPREFIX}/vis

.PHONY: all clean dist install uninstall debug profile coverage test test-update luadoc luadoc-all luacheck man docker

=== debian/changelog ===
vis (0.4-2) unstable; urgency=medium

  * Bump to Standards-Version 4.1.3
  * Bump compat level to 11
  * Packaging repository moved to salsa
  * Only link with needed libraries (ld --as-needed)

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 19 Feb 2018 18:13:23 +0100

vis (0.4-1) unstable; urgency=medium

  * New upstream version
  * Bump debian/compat level to 10
  * Remove upstreamed patches
  * Patch the missing copyright notice for the strace lexer
  * Add debian/copyright entry for the strace lexer
  * Bump standards version
  * Remove extra license files
  * Add more options to d/gbp.conf
  * Add Vcs- fields to d/control
  * Specify the packaging branch in the Vcs-Git field
  * Fix d/gbp.conf (options must be specified without the 'git-' prefix)

 -- Paride Legovini <pl@ninthfloor.org>  Tue, 25 Jul 2017 15:22:33 +0200

vis (0.3-2) unstable; urgency=medium

  * Fix compilation on GNU Hurd systems (Closes: #860513)

 -- Paride Legovini <pl@ninthfloor.org>  Sat, 13 May 2017 12:29:13 +0200

vis (0.3-1) unstable; urgency=medium

  * Initial release. (Closes: #838895)

 -- Paride Legovini <pl@ninthfloor.org>  Fri, 31 Mar 2017 16:00:13 +0200

=== debian/control ===
Source: vis
Section: editors
Priority: optional
Maintainer: Paride Legovini <pl@ninthfloor.org>
Build-Depends: libncursesw5-dev, libtermkey1, liblua5.3-dev,
 libtermkey-dev, libtre-dev, debhelper (>= 11~), pkg-config
Standards-Version: 4.1.3
Homepage: https://github.com/martanne/vis
Vcs-Git: https://salsa.debian.org/debian/vis.git -b debian/sid
Vcs-Browser: https://salsa.debian.org/debian/vis

Package: vis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: lua-lpeg
Provides: editor
Description: Modern, legacy free, simple yet efficient vim-like editor
 Vis aims to be a modern, legacy free, simple yet efficient editor
 combining the strengths of both vi(m) and sam. It extends vi's modal
 editing with support for multiple cursors/selections and combines it
 with sam's structural regular expression based command language.
 .
 As an universal editor it has decent Unicode support and should cope
 with arbitrary files including: large, binary or single-line ones.
 Syntax highlighting is provided using Parsing Expression Grammars which
 can be conveniently expressed using Lua in the form of LPeg.
 .
 The editor core is written in a reasonable amount of clean (your mileage
 may vary), modern and legacy free C code, enabling it to run in resource
 constrained environments. The implementation should be easy to hack
 on and encourage experimentation. There also exists a Lua API for
 in-process extensions.
 .
 Vis strives to be simple and focuses on its core task: efficient text
 management. Clipboard and digraph handling as well as a fuzzy file open
 dialog are all provided by independent utilities.
 .
 The intention is not to be bug for bug compatible with vi(m), instead
 the aim is to provide powerful editing features based on an elegant
 design and clean implementation.

=== debian/rules ===
#!/usr/bin/make -f

# https://pkg-perl.alioth.debian.org/debhelper.html#Occasionally_Useful
PACKAGE = $(shell dh_listpackages)
TMP     = $(CURDIR)/debian/$(PACKAGE)

# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	# Vis configure script it not generated by autoconf, so it does not
	# accept all the options given by dh_auto_configure. It *almost* works,
	# but we end up with a wrong mandir. This is a possible workaround:
	#
	# dh_auto_configure -- --mandir='$$(PREFIX)/share/man/'
	#
	# but still we're calling the configure script with a lot of options
	# it doesn't actually understand. I prefer to just run the script
	# manually, and dh_auto_configure(1) agrees (see the DESCRIPTION).
	#
	# So:
	#
	./configure --prefix=/usr

override_dh_auto_install:
	dh_auto_install

	# Remove extra license files
	rm -v $(TMP)/usr/share/doc/vis/LICENSE $(TMP)/usr/share/vis/lexers/LICENSE

override_dh_auto_test:

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/vis-$1\.tar\.gz/ \
  https://github.com/martanne/vis/tags .*/v?(\d\S*)\.tar\.gz

## vis 0.5+ts

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 DOCUMENTATION = LICENSE README.md
 
-VERSION = v0.4
+VERSION = v0.5
 
 CONFIG_HELP ?= 1
 CONFIG_CURSES ?= 1
@@ -47,6 +47,7 @@
 	$(LDFLAGS_SELINUX) $(LDFLAGS_TRE) $(LDFLAGS_LUA) $(LDFLAGS_LPEG) $(LDFLAGS_STD)
 
 STRIP?=strip
+TAR?=tar
 
 all: $(ELF)
 
@@ -72,9 +73,10 @@
 	echo '#ifndef VIS_SINGLE_PAYLOAD_H' > $@
 	echo '#define VIS_SINGLE_PAYLOAD_H' >> $@
 	echo 'static unsigned char vis_single_payload[] = {' >> $@
-	tar --mtime='2014-07-15 01:23Z' --owner=0 --group=0 --numeric-owner --mode='a+rX-w' -c \
+	$(TAR) --mtime='2014-07-15 01:23Z' --owner=0 --group=0 --numeric-owner --mode='a+rX-w' -c \
 		$(EXECUTABLES) $$(find lua -name '*.lua' | LC_ALL=C sort) | xz -T 1 | \
-		od -t x1 -A none -v | sed 's/\([0-9a-f]\+\)/0x\1,/g;$$s/,$$/ };/' >> $@
+		od -t x1 -v | sed -e 's/^[0-9a-fA-F]\{1,\}//g' -e 's/\([0-9a-f]\{2\}\)/0x\1,/g' >> $@
+	echo '};' >> $@
 	echo '#endif' >> $@
 
 vis-single: vis-single.c vis-single-payload.inc
@@ -82,9 +84,10 @@
 	${STRIP} $@
 
 docker: clean
-	docker rm -f vis || true
 	docker build -t vis .
 	docker run --rm -d --name vis vis tail -f /dev/null
+	docker exec vis apk update
+	docker exec vis apk upgrade
 	docker cp . vis:/tmp/vis
 	docker exec vis sed -i '/^VERSION/c VERSION = $(VERSION)' Makefile
 	docker exec vis ./configure CC='cc --static'

=== test/Makefile ===
test:
	@$(MAKE) -C core
	@$(MAKE) -C lua
	@$(MAKE) -C vis
	@$(MAKE) -C sam
	@$(MAKE) -C vim

clean:
	@$(MAKE) -C core clean
	@$(MAKE) -C lua clean
	@$(MAKE) -C vis clean
	@$(MAKE) -C sam clean
	@$(MAKE) -C vim clean

.PHONY: test clean

=== test/core/Makefile ===
-include ../../config.mk

ALL = buffer-test map-test array-test text-test
SRC = $(wildcard ccan/*/*.c)
CFLAGS += -I. -I../.. -DBUFFER_SIZE=4 -DBLOCK_SIZE=4

test: $(ALL)
	@./buffer-test
	@./map-test
	@./array-test
	@./text-test

config.h:
	@echo Generating ccan configuration header
	@${CC} ccan-config.c -o ccan-config && ./ccan-config > config.h

text-test: config.h text-test.c ../../text.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${SRC} ${LDFLAGS} -o $@

buffer-test: config.h buffer-test.c ../../buffer.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${SRC} ${LDFLAGS} -o $@

map-test: config.h map-test.c ../../map.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${SRC} ${LDFLAGS} -o $@

array-test: config.h array-test.c ../../array.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${SRC} ${LDFLAGS} -o $@

debug: clean
	$(MAKE) CFLAGS_EXTRA='${CFLAGS_EXTRA} ${CFLAGS_DEBUG}'

coverage: clean
	$(MAKE) CFLAGS_EXTRA='--coverage'

asan: clean
	$(MAKE) CFLAGS_EXTRA='-fsanitize=address'

ubsan: clean
	$(MAKE) CFLAGS_EXTRA='-fsanitize=undefined'

msan: clean
	$(MAKE) CFLAGS_EXTRA='-g -fsanitize=memory'

valgrind: clean ${ALL}
	@for test in ${ALL}; do \
		valgrind --leak-check=full --log-file="$$test.valgrind" "./$$test"; \
		cat "$$test.valgrind"; \
		grep LEAK "$$test.valgrind" >/dev/null && exit 1 || true; \
	done

tis: clean
	$(MAKE) CC="tis-interpreter.sh --cc" CFLAGS='"${CFLAGS} ${CFLAGS_STD} -DHAVE_MEMRCHR=0 -DTIS_INTERPRETER=1"' CFLAGS_STD='' CFLAGS_LIBC='' LDFLAGS='#' $(ALL)

clean:
	@echo cleaning
	@rm -f $(ALL)
	@rm -f *.gcov *.gcda *.gcno
	@rm -f *.valgrind

.PHONY: clean debug coverage tis valgrind asan ubsan msan

=== test/fuzz/Makefile ===
-include ../../config.mk

ALL = text-fuzzer buffer-fuzzer
CC = afl-gcc
CFLAGS += -I. -I../.. -DBUFFER_SIZE=4 -DBLOCK_SIZE=4

test: $(ALL)

text-fuzzer: text-fuzzer.c fuzzer.h ../../text.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c
	@echo Compiling $@ binary
	${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_EXTRA} ${filter %.c, $^} ${LDFLAGS} -o $@

buffer-fuzzer: buffer-fuzzer.c fuzzer.h ../../buffer.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_EXTRA} ${filter %.c, $^} ${LDFLAGS} -o $@

debug: clean
	$(MAKE) CFLAGS_EXTRA='${CFLAGS_EXTRA} ${CFLAGS_DEBUG}'

afl-fuzz-text: text-fuzzer
	@mkdir -p "results/$<"
	@afl-fuzz -i - -x "dictionaries/$<.dict" -o "results/$<" -- "./$<" || \
	 afl-fuzz -i "inputs/$<" -x "dictionaries/$<.dict" -o "results/$<" -- "./$<"

afl-fuzz-buffer: buffer-fuzzer
	@mkdir -p "results/$<"
	@afl-fuzz -i - -x "dictionaries/$<.dict" -o "results/$<" -- "./$<" || \
	 afl-fuzz -i "inputs/$<" -x "dictionaries/$<.dict" -o "results/$<" -- "./$<"

clean:
	@echo cleaning
	@rm -f $(ALL)

distclean: clean
	@rm -rf results/

.PHONY: clean distclean debug afl-fuzz-text afl-fuzz-buffer

=== test/vis/Makefile ===
test: ../../vis clean
	@./test.sh

../../vis: ../../*.[ch]
	@echo Compiling vis
	@$(MAKE) -C ../..

clean:
	@echo cleaning
	@find . -name '*.out' -o -name '*.err' | xargs rm -f

.PHONY: clean test

=== debian/changelog ===
vis (0.5+ts-3) unstable; urgency=medium

  * Disable the vim tests
  * Run the test/vis tests as autopkgtest

 -- Paride Legovini <pl@ninthfloor.org>  Tue, 08 May 2018 14:34:19 +0000

vis (0.5+ts-2) unstable; urgency=medium

  * Build-depend on libselinux1-dev only on Linux systems

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 16 Apr 2018 21:46:38 +0000

vis (0.5+ts-1) unstable; urgency=medium

  * Enable the test suite (git submodule):
    - d/rules: do not override_dh_auto_test.
    - d/rules: cleanup the test suite after building.
    - d/gbp.conf: add ‘submodules = True’.
    - New build-deps: locales-all, lua-busted, lua-lpeg, vim.
    - Cover the test suite in d/copyright.
    - Add the ‘+ts’ version string to differentiate the new .orig
      tarball now containing the test suite from the previous one.
    - Patch: delete broken test depending on external sed(1)
      invocation (cherry-pick, upstream commit 90dd04f).
    - Patch: make sure $TERM is set (cherry pick, c824ec2).
  * Build with POSIX acl support (build-depend on libacl1-dev).
  * Build with SELinux support (build-depend on libselinux1-dev).
  * Bump Standards-Version to 4.1.4 (no changes needed).
  * debian/* relicensed as ISC.
  * d/watch: dversionmangle: remove version string

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 16 Apr 2018 08:41:36 +0000

vis (0.5-1) unstable; urgency=medium

  * New upstream version 0.5
  * Drop upstreamed patches
  * New patches:
    - Remove execution file permission from clojure.lua
      (upstreamed, cherry-picked)
    - Remove broken manpage POSIX referemce
      (upstreamed, cherry-picked)
  * Add upstream metadata file (DEP12)
  * debian/copyright:
    - updated copyright years
    - added the new lexers
    - lexers copyright entries consolidated in a single section
    - point to ‘common-licenses’ instead of reporting the full CC0 license

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 28 Mar 2018 07:19:54 +0000

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,19 @@
 Section: editors
 Priority: optional
 Maintainer: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: libncursesw5-dev, libtermkey1, liblua5.3-dev,
- libtermkey-dev, libtre-dev, debhelper (>= 11~), pkg-config
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11~),
+               libncursesw5-dev,
+               libtermkey1,
+               liblua5.3-dev,
+               libtermkey-dev,
+               libtre-dev,
+               pkg-config,
+               libacl1-dev,
+               libselinux1-dev [linux-any],
+               locales-all,
+               lua-busted,
+               lua-lpeg
+Standards-Version: 4.1.4
 Homepage: https://github.com/martanne/vis
 Vcs-Git: https://salsa.debian.org/debian/vis.git -b debian/sid
 Vcs-Browser: https://salsa.debian.org/debian/vis

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+#export DH_VERBOSE = 1
 
 # https://pkg-perl.alioth.debian.org/debhelper.html#Occasionally_Useful
 PACKAGE = $(shell dh_listpackages)
@@ -32,4 +34,22 @@
 	# Remove extra license files
 	rm -v $(TMP)/usr/share/doc/vis/LICENSE $(TMP)/usr/share/vis/lexers/LICENSE
 
+# The tests need to be run in an UTF-8 aware environment.
+override_dh_auto_test: LC_ALL=en_US.UTF-8
 override_dh_auto_test:
+	# The vim tests harness is not solid, let's skip them for the moment.
+	# Upstream mentioned the possibility of phasing them out entirely.
+	make -C test/core
+	make -C test/lua
+	make -C test/vis
+
+override_dh_auto_clean:
+	dh_auto_clean
+
+	# Cleanup the test suite submodule too.
+	$(MAKE) -C test clean
+
+	# Note: it doesn't really clean up everything.
+	# Upstream issue: https://github.com/martanne/vis-test/issues/13.
+	# Let's manually remove the test build leftovers.
+	rm -f test/core/ccan-config test/core/config.h test/util/keys

=== debian/tests/control ===
Depends: @, locales-all
Restrictions: needs-recommends
Test-Command: cd test/vis && LC_ALL=en_US.UTF-8 VIS=vis ./test.sh

## vis 0.6

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 DOCUMENTATION = LICENSE README.md
 
-VERSION = v0.5
+VERSION = v0.6
 
 CONFIG_HELP ?= 1
 CONFIG_CURSES ?= 1
@@ -48,6 +48,7 @@
 
 STRIP?=strip
 TAR?=tar
+DOCKER?=docker
 
 all: $(ELF)
 
@@ -83,17 +84,25 @@
 	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -luntar -llzma -o $@
 	${STRIP} $@
 
-docker: clean
-	docker build -t vis .
-	docker run --rm -d --name vis vis tail -f /dev/null
-	docker exec vis apk update
-	docker exec vis apk upgrade
-	docker cp . vis:/tmp/vis
-	docker exec vis sed -i '/^VERSION/c VERSION = $(VERSION)' Makefile
-	docker exec vis ./configure CC='cc --static'
-	docker exec vis make clean vis-single
-	docker cp vis:/tmp/vis/vis-single vis
-	docker kill vis
+docker-kill:
+	-$(DOCKER) kill vis && $(DOCKER) wait vis
+
+docker: docker-kill clean
+	$(DOCKER) build -t vis .
+	$(DOCKER) run --rm -d --name vis vis tail -f /dev/null
+	$(DOCKER) exec vis apk update
+	$(DOCKER) exec vis apk upgrade
+	$(DOCKER) cp . vis:/build/vis
+	$(DOCKER) exec -w /build/vis vis ./configure CC='cc --static' \
+		--enable-acl \
+		--enable-lua \
+		--enable-lpeg-static
+	$(DOCKER) exec -w /build/vis vis make VERSION="$(VERSION)" clean vis-single
+	$(DOCKER) cp vis:/build/vis/vis-single vis
+	$(DOCKER) kill vis
+
+docker-clean: docker-kill clean
+	-$(DOCKER) image rm vis
 
 debug: clean
 	@$(MAKE) CFLAGS_EXTRA='${CFLAGS_EXTRA} ${CFLAGS_DEBUG}'
@@ -123,7 +132,7 @@
 man:
 	@for m in ${MANUALS}; do \
 		echo "Generating $$m"; \
-		sed -e "s/VERSION/${VERSION}/" "man/$$m" | mandoc -W warning -T utf8 -T xhtml -O man=%N.%S.html -O style=mandoc.css 1> "man/$$m.html" || true; \
+		sed -e "s/VERSION/${VERSION}/" "man/$$m" | mandoc -W warning -T utf8 -T html -O man=%N.%S.html -O style=mandoc.css 1> "man/$$m.html" || true; \
 	done
 
 luadoc:
@@ -136,10 +145,6 @@
 	@luacheck --config .luacheckrc lua test/lua | less -RFX
 
 install: $(ELF)
-	@echo stripping executable
-	@for e in $(ELF); do \
-		${STRIP} "$$e"; \
-	done
 	@echo installing executable files to ${DESTDIR}${PREFIX}/bin
 	@mkdir -p ${DESTDIR}${PREFIX}/bin
 	@for e in ${EXECUTABLES}; do \
@@ -165,6 +170,12 @@
 		chmod 644 "${DESTDIR}${MANPREFIX}/man1/$$m"; \
 	done
 
+install-strip: install
+	@echo stripping executables
+	@for e in $(ELF); do \
+		${STRIP} ${DESTDIR}${PREFIX}/bin/"$$e"; \
+	done
+
 uninstall:
 	@echo removing executable file from ${DESTDIR}${PREFIX}/bin
 	@for e in ${EXECUTABLES}; do \
@@ -181,4 +192,4 @@
 	@echo removing support files from ${DESTDIR}${SHAREPREFIX}/vis
 	@rm -rf ${DESTDIR}${SHAREPREFIX}/vis
 
-.PHONY: all clean dist install uninstall debug profile coverage test test-update luadoc luadoc-all luacheck man docker
+.PHONY: all clean dist install install-strip uninstall debug profile coverage test test-update luadoc luadoc-all luacheck man docker-kill docker docker-clean

=== test/core/Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 	$(MAKE) CFLAGS_EXTRA='-fsanitize=undefined'
 
 msan: clean
-	$(MAKE) CFLAGS_EXTRA='-g -fsanitize=memory'
+	$(MAKE) CFLAGS_EXTRA='-fsanitize=memory -fsanitize-memory-track-origins'
 
 valgrind: clean ${ALL}
 	@for test in ${ALL}; do \
@@ -57,6 +57,7 @@
 
 clean:
 	@echo cleaning
+	@rm -f ccan-config config.h
 	@rm -f $(ALL)
 	@rm -f *.gcov *.gcda *.gcno
 	@rm -f *.valgrind

=== test/fuzz/Makefile ===
-include ../../config.mk

ALL = text-fuzzer text-libfuzzer buffer-fuzzer
CC = afl-gcc
CFLAGS += -I. -I../.. -DBUFFER_SIZE=4 -DBLOCK_SIZE=4

TEXT_SRC = ../../text.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c

test: $(ALL)

text-fuzzer: text-fuzzer.c fuzzer.h $(TEXT_SRC)
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${LDFLAGS} -o $@

text-libfuzzer: text-fuzzer.c fuzzer.h $(TEXT_SRC)
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} -DLIBFUZZER ${filter %.c, $^} -fsanitize=fuzzer,address,undefined ${LDFLAGS} -o $@

buffer-fuzzer: buffer-fuzzer.c fuzzer.h ../../buffer.c
	@echo Compiling $@ binary
	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${LDFLAGS} -o $@

debug: clean
	$(MAKE) CFLAGS_EXTRA='${CFLAGS_EXTRA} ${CFLAGS_DEBUG}'

afl-fuzz-text: text-fuzzer
	@mkdir -p "results/$<"
	@afl-fuzz -i - -x "dictionaries/$<.dict" -o "results/$<" -- "./$<" || \
	 afl-fuzz -i "inputs/$<" -x "dictionaries/$<.dict" -o "results/$<" -- "./$<"

libfuzzer-text: text-libfuzzer
	@mkdir -p "results/$<"
	@./$< -close_fd_mask=1 -only_ascii=1 -print_final_stats=1 "-dict=dictionaries/$<.dict" "inputs/$<" "results/$<"

afl-fuzz-buffer: buffer-fuzzer
	@mkdir -p "results/$<"
	@afl-fuzz -i - -x "dictionaries/$<.dict" -o "results/$<" -- "./$<" || \
	 afl-fuzz -i "inputs/$<" -x "dictionaries/$<.dict" -o "results/$<" -- "./$<"

clean:
	@echo cleaning
	@rm -f $(ALL)

distclean: clean
	@rm -rf results/

.PHONY: clean distclean debug afl-fuzz-text libfuzzer-text afl-fuzz-buffer

=== debian/changelog ===
vis (0.6-3) unstable; urgency=medium

  * Run the tests only on: amd64, arm64, ppc64el.

 -- Paride Legovini <paride@debian.org>  Wed, 29 Jul 2020 22:59:29 +0000

vis (0.6-2) unstable; urgency=medium

  * d/control: Build-Depend on vim and 9base only on amd64 due to
    package availability and flaky tests.
  * d/gbp.conf: move the pristine-tar settings to the DEFAULT section.

 -- Paride Legovini <paride@debian.org>  Tue, 07 Jul 2020 18:17:56 +0000

vis (0.6-1) unstable; urgency=medium

  * New upstream version 0.6.
  * d/control:
    - Bump Standards-Version to 4.5.0 (no changes needed).
    - Bump the dh compat level to 13.
    - Build-Depend on 9base and vim (needed test against sam and vim).
    - Use the paride@debian.org alias in Uploaders.
    - Add Multi-Arch: foreign.
    - Add Rules-Requires-Root: no.
    - Rewrap the file (wrap-and-sort -st).
  * d/gbp.conf:
    - Unset upstream-branch (imports are done from upstream git).
    - Always create the (xz compressed) pristine-tar.
  * d/rules:
    - Re-enable the vim tests.
    - Stop enforcing -Wl,--as-needed (now done by default).
    - Drop the test suite cleanup commands; use d/clean instead.
    - dh_auto_test: set LANG=C.UTF-8.
      See: https://github.com/martanne/vis-test/issues/25.
  * d/copyright: update copyright entry for debian/*.
  * autopkgtests:
    - Drop the needs-recommends requirement (deprecated).
    - Do not set LC_ALL=en_US.UTF-8 (now done upstream).
  * Drop all the patches (upstreamed).

 -- Paride Legovini <paride@debian.org>  Mon, 06 Jul 2020 22:33:26 +0000

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,31 @@
 Source: vis
 Section: editors
 Priority: optional
-Maintainer: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper (>= 11~),
-               libncursesw5-dev,
-               libtermkey1,
-               liblua5.3-dev,
-               libtermkey-dev,
-               libtre-dev,
-               pkg-config,
-               libacl1-dev,
-               libselinux1-dev [linux-any],
-               locales-all,
-               lua-busted,
-               lua-lpeg
-Standards-Version: 4.1.4
+Maintainer: Paride Legovini <paride@debian.org>
+Build-Depends:
+ 9base [amd64 arm64 ppc64el],
+ debhelper-compat (= 13),
+ libacl1-dev,
+ liblua5.3-dev,
+ libncursesw5-dev,
+ libselinux1-dev [linux-any],
+ libtermkey-dev,
+ libtermkey1,
+ libtre-dev,
+ locales-all,
+ lua-busted,
+ lua-lpeg,
+ pkg-config,
+ vim [amd64 arm64 ppc64el],
+Standards-Version: 4.5.0
 Homepage: https://github.com/martanne/vis
-Vcs-Git: https://salsa.debian.org/debian/vis.git -b debian/sid
+Vcs-Git: https://salsa.debian.org/debian/vis.git
 Vcs-Browser: https://salsa.debian.org/debian/vis
+Rules-Requires-Root: no
 
 Package: vis
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: lua-lpeg
 Provides: editor
 Description: Modern, legacy free, simple yet efficient vim-like editor

=== debian/tests/control ===
Depends: @, locales-all, lua-lpeg
Test-Command: cd test/vis && VIS=vis ./test.sh

## vis 0.7

=== Makefile ===
--- 
+++ 
@@ -2,10 +2,31 @@
 
 REGEX_SRC ?= text-regex.c
 
-SRC = array.c buffer.c libutf.c main.c map.c \
-	sam.c text.c text-motions.c text-objects.c text-util.c \
-	ui-terminal.c view.c vis.c vis-lua.c vis-modes.c vis-motions.c \
-	vis-operators.c vis-registers.c vis-marks.c vis-prompt.c vis-text-objects.c $(REGEX_SRC)
+SRC = array.c \
+	buffer.c \
+	libutf.c \
+	main.c \
+	map.c \
+	sam.c \
+	text.c \
+	text-common.c \
+	text-io.c \
+	text-iterator.c \
+	text-motions.c \
+	text-objects.c \
+	text-util.c \
+	ui-terminal.c \
+	view.c \
+	vis.c \
+	vis-lua.c \
+	vis-marks.c \
+	vis-modes.c \
+	vis-motions.c \
+	vis-operators.c \
+	vis-prompt.c \
+	vis-registers.c \
+	vis-text-objects.c \
+	$(REGEX_SRC)
 
 ELF = vis vis-menu vis-digraph
 EXECUTABLES = $(ELF) vis-clipboard vis-complete vis-open
@@ -14,7 +35,7 @@
 
 DOCUMENTATION = LICENSE README.md
 
-VERSION = v0.6
+VERSION = v0.7
 
 CONFIG_HELP ?= 1
 CONFIG_CURSES ?= 1
@@ -121,11 +142,19 @@
 	[ -e test/Makefile ] || $(MAKE) test-update
 	@$(MAKE) -C test
 
+testclean:
+	@echo cleaning the test artifacts
+	[ ! -e test/Makefile ] || $(MAKE) -C test clean
+
 clean:
 	@echo cleaning
 	@rm -f $(ELF) vis-single vis-single-payload.inc vis-*.tar.gz *.gcov *.gcda *.gcno
 
-dist: clean
+distclean: clean testclean
+	@echo cleaning build configuration
+	@rm -f config.h config.mk
+
+dist: distclean
 	@echo creating dist tarball
 	@git archive --prefix=vis-${VERSION}/ -o vis-${VERSION}.tar.gz HEAD
 
@@ -192,4 +221,4 @@
 	@echo removing support files from ${DESTDIR}${SHAREPREFIX}/vis
 	@rm -rf ${DESTDIR}${SHAREPREFIX}/vis
 
-.PHONY: all clean dist install install-strip uninstall debug profile coverage test test-update luadoc luadoc-all luacheck man docker-kill docker docker-clean
+.PHONY: all clean testclean dist distclean install install-strip uninstall debug profile coverage test test-update luadoc luadoc-all luacheck man docker-kill docker docker-clean

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = VisEditor
SOURCEDIR     = .
BUILDDIR      = build/sphinx

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== test/Makefile ===
--- 
+++ 
@@ -11,5 +11,6 @@
 	@$(MAKE) -C vis clean
 	@$(MAKE) -C sam clean
 	@$(MAKE) -C vim clean
+	@$(MAKE) -C util clean
 
 .PHONY: test clean

=== test/core/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	@echo Generating ccan configuration header
 	@${CC} ccan-config.c -o ccan-config && ./ccan-config > config.h
 
-text-test: config.h text-test.c ../../text.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c
+text-test: config.h text-test.c ../../text.c ../../text-common.c ../../text-io.c ../../text-iterator.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c ../../array.c
 	@echo Compiling $@ binary
 	@${CC} ${CFLAGS} ${CFLAGS_STD} ${CFLAGS_LIBC} ${CFLAGS_EXTRA} ${filter %.c, $^} ${SRC} ${LDFLAGS} -o $@
 
@@ -58,6 +58,7 @@
 clean:
 	@echo cleaning
 	@rm -f ccan-config config.h
+	@rm -f data symlink hardlink
 	@rm -f $(ALL)
 	@rm -f *.gcov *.gcda *.gcno
 	@rm -f *.valgrind

=== test/lua/Makefile ===
all: clean ../../vis test

../../vis: ../../*.[ch]
	@echo Compiling vis
	@$(MAKE) -C ../..

clean:
	@rm -f *.out *.err *.busted

test:
	@./test.sh

%: %.in
	@./test.sh $@

.PHONY: all clean test

=== test/sam/Makefile ===
test: ../../vis
	@./test.sh

../../vis: ../../*.[ch]
	@echo Compiling vis
	@$(MAKE) -C ../..

clean:
	@echo cleaning
	@find . -name '*.out' -o -name '*.err' | xargs rm -f

.PHONY: clean test

=== test/util/Makefile ===
-include ../../config.mk

keys: keys.c
	@echo Compiling keys utility
	$(CC) $(CFLAGS) $(CFLAGS_TERMKEY) keys.c $(LDFLAGS) $(LDFLAGS_TERMKEY) $(LDFLAGS_CURSES) -o keys

clean:
	@echo cleaning
	@rm -f keys

.PHONY: clean

=== test/vim/Makefile ===
test: ../../vis ../util/keys
	@./test.sh

../../vis: ../../*.[ch]
	@echo Compiling vis
	@$(MAKE) -C ../..

../util/keys: ../util/keys.c
	@$(MAKE) -C ../util

clean:
	@echo cleaning
	@find . -name '*.out' -o -name '*.err' | xargs rm -f

.PHONY: clean test

=== debian/changelog ===
vis (0.7-2) unstable; urgency=medium

  * d/control: drop the 9base B-Dep (RC-buggy test dependency).
  * d/*: apply wrap-and-sort -bast (cosmetic).

 -- Paride Legovini <paride@debian.org>  Wed, 03 Mar 2021 16:20:36 +0000

vis (0.7-1) unstable; urgency=medium

  * New upstream version 0.7.
  * d/control: Bump Standards-Version to 4.5.1, no changes needed.
  * d/gbp.conf: debian-branch = debian/latest (DEP-14).
  * d/s/lintian-overrides: override package-does-not-install-examples for
    test/sam/examples/. We're not supposed to install the test suite examples.

 -- Paride Legovini <paride@debian.org>  Wed, 06 Jan 2021 23:02:44 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Paride Legovini <paride@debian.org>
 Build-Depends:
- 9base [amd64 arm64 ppc64el],
  debhelper-compat (= 13),
  libacl1-dev,
  liblua5.3-dev,
@@ -17,7 +16,7 @@
  lua-lpeg,
  pkg-config,
  vim [amd64 arm64 ppc64el],
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/martanne/vis
 Vcs-Git: https://salsa.debian.org/debian/vis.git
 Vcs-Browser: https://salsa.debian.org/debian/vis
@@ -25,9 +24,13 @@
 
 Package: vis
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Recommends: lua-lpeg
-Provides: editor
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Recommends:
+ lua-lpeg,
+Provides:
+ editor,
 Description: Modern, legacy free, simple yet efficient vim-like editor
  Vis aims to be a modern, legacy free, simple yet efficient editor
  combining the strengths of both vi(m) and sam. It extends vi's modal

=== debian/rules ===
#!/usr/bin/make -f

# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Some tests are flaky on some architectures, with failures
# which are difficult to reproduce. Let's run the tests only
# on the architectures where they behave well.
ifeq (,$(filter amd64 arm64 ppc64el,$(DEB_HOST_ARCH)))
	export DEB_BUILD_OPTIONS += nocheck
endif

%:
	dh $@

override_dh_auto_configure:
	# Vis configure script it not generated by autoconf, so it does not
	# accept all the options given by dh_auto_configure. It *almost* works,
	# but we end up with a wrong mandir. This is a possible workaround:
	#
	# dh_auto_configure -- --mandir='$$(PREFIX)/share/man/'
	#
	# but still we're calling the configure script with a lot of options
	# it doesn't actually understand. I prefer to just run the script
	# manually, and dh_auto_configure(1) agrees (see the DESCRIPTION).
	#
	# So:
	#
	./configure --prefix=/usr

override_dh_auto_test:
	# https://github.com/martanne/vis-test/issues/25
	dh_auto_test -- LANG=C.UTF-8

override_dh_auto_install:
	dh_auto_install -- DOCUMENTATION=README.md

	# Remove extra files
	rm -v debian/vis/usr/share/vis/lexers/LICENSE
	rm -v debian/vis/usr/share/vis/lexers/README.md

override_dh_auto_clean:
	dh_auto_clean

	# Cleanup the test suite submodule.
	# Remove if https://github.com/martanne/vis/pull/848 lands.
	$(MAKE) -C test clean

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/vis-$1\.tar\.gz/,dversionmangle=s/\+ts$// \
  https://github.com/martanne/vis/tags .*/v?(\d\S*)\.tar\.gz

## vis 0.8

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 
 DOCUMENTATION = LICENSE README.md
 
-VERSION = v0.7
+VERSION = 0.8
 
 CONFIG_HELP ?= 1
 CONFIG_CURSES ?= 1

=== test/fuzz/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 CC = afl-gcc
 CFLAGS += -I. -I../.. -DBUFFER_SIZE=4 -DBLOCK_SIZE=4
 
-TEXT_SRC = ../../text.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c
+TEXT_SRC = ../../text.c ../../text-common.c ../../text-io.c ../../text-iterator.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c ../../array.c
 
 test: $(ALL)

=== debian/changelog ===
vis (0.8-1) unstable; urgency=medium

  * New upstream version 0.8
  * d/control: bump Standards-Version to 4.6.1, no changes needed
  * d/copyright: update copyright years for debian/*
  * d/lintian-overrides: refresh overrides
  * d/watch: switch to mode=git.
    We only use the watch file to detect new upstream versions, as the
    packaging follows a pure-git workflow (gbp import-ref). What we care
    about are git tags, so let's directly watch for those.

 -- Paride Legovini <paride@debian.org>  Mon, 14 Nov 2022 09:47:41 +0000

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  lua-lpeg,
  pkg-config,
  vim [amd64 arm64 ppc64el],
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/martanne/vis
 Vcs-Git: https://salsa.debian.org/debian/vis.git
 Vcs-Browser: https://salsa.debian.org/debian/vis

## vis 0.9

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,9 @@
 	vis-prompt.c \
 	vis-registers.c \
 	vis-text-objects.c \
+	vis-subprocess.c \
 	$(REGEX_SRC)
+OBJ = $(SRC:%.c=obj/%.o)
 
 ELF = vis vis-menu vis-digraph
 EXECUTABLES = $(ELF) vis-clipboard vis-complete vis-open
@@ -35,7 +37,7 @@
 
 DOCUMENTATION = LICENSE README.md
 
-VERSION = 0.8
+VERSION = 0.9
 
 CONFIG_HELP ?= 1
 CONFIG_CURSES ?= 1
@@ -45,7 +47,7 @@
 CONFIG_ACL ?= 0
 CONFIG_SELINUX ?= 0
 
-CFLAGS_STD ?= -std=c99 -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700 -DNDEBUG
+CFLAGS_STD ?= -std=c99 -U_XOPEN_SOURCE -D_XOPEN_SOURCE=700 -DNDEBUG -MMD
 CFLAGS_STD += -DVERSION=\"${VERSION}\"
 LDFLAGS_STD ?= -lc
 
@@ -79,14 +81,25 @@
 config.mk:
 	@touch $@
 
-vis: config.h config.mk *.c *.h
-	${CC} ${CFLAGS} ${CFLAGS_VIS} ${CFLAGS_EXTRA} ${SRC} ${LDFLAGS} ${LDFLAGS_VIS} -o $@
+obj/.tstamp:
+	mkdir obj
+	touch obj/.tstamp
+
+obj/main.o: config.h
+
+$(OBJ): config.mk obj/.tstamp
+	${CC} ${CFLAGS} ${CFLAGS_VIS} ${CFLAGS_EXTRA} -o $@ -c $(@:obj/%.o=%.c)
+
+-include obj/*.d
+
+vis: ${OBJ}
+	${CC} -o $@ ${OBJ} ${LDFLAGS} ${LDFLAGS_VIS} ${LDFLAGS_EXTRA}
 
 vis-menu: vis-menu.c
-	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -o $@
+	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} ${LDFLAGS_EXTRA} -o $@
 
 vis-digraph: vis-digraph.c
-	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} -o $@
+	${CC} ${CFLAGS} ${CFLAGS_AUTO} ${CFLAGS_STD} ${CFLAGS_EXTRA} $< ${LDFLAGS} ${LDFLAGS_STD} ${LDFLAGS_AUTO} ${LDFLAGS_EXTRA} -o $@
 
 vis-single-payload.inc: $(EXECUTABLES) lua/*
 	for e in $(ELF); do \
@@ -97,7 +110,7 @@
 	echo 'static unsigned char vis_single_payload[] = {' >> $@
 	$(TAR) --mtime='2014-07-15 01:23Z' --owner=0 --group=0 --numeric-owner --mode='a+rX-w' -c \
 		$(EXECUTABLES) $$(find lua -name '*.lua' | LC_ALL=C sort) | xz -T 1 | \
-		od -t x1 -v | sed -e 's/^[0-9a-fA-F]\{1,\}//g' -e 's/\([0-9a-f]\{2\}\)/0x\1,/g' >> $@
+		od -t x1 -A n -v | sed 's/\([0-9a-f]\{2\}\)/0x\1,/g' >> $@
 	echo '};' >> $@
 	echo '#endif' >> $@
 
@@ -132,7 +145,7 @@
 	@$(MAKE) CFLAGS_AUTO='' LDFLAGS_AUTO='' CFLAGS_EXTRA='-pg -O2'
 
 coverage: clean
-	@$(MAKE) CFLAGS_EXTRA='--coverage'
+	@$(MAKE) CFLAGS_EXTRA='--coverage' LDFLAGS_EXTRA='--coverage'
 
 test-update:
 	git submodule init
@@ -148,7 +161,8 @@
 
 clean:
 	@echo cleaning
-	@rm -f $(ELF) vis-single vis-single-payload.inc vis-*.tar.gz *.gcov *.gcda *.gcno
+	@rm -rf obj
+	@rm -f $(ELF) vis-single vis-single-payload.inc vis-*.tar.gz *.gcov *.gcda *.gcno *.d
 
 distclean: clean testclean
 	@echo cleaning build configuration

=== test/core/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 config.h:
 	@echo Generating ccan configuration header
-	@${CC} ccan-config.c -o ccan-config && ./ccan-config > config.h
+	@${CC} ccan-config.c -o ccan-config && ./ccan-config "${CC}" ${CFLAGS} > config.h
 
 text-test: config.h text-test.c ../../text.c ../../text-common.c ../../text-io.c ../../text-iterator.c ../../text-util.c ../../text-motions.c ../../text-objects.c ../../text-regex.c ../../array.c
 	@echo Compiling $@ binary

=== debian/changelog ===
vis (0.9-1) unstable; urgency=medium

  * New upstream version 0.8 (Closes: #1050536)
  * d/control: bump Standards-Version to 4.7.0, no changes needed
  * d/control: replace obsolete B-D on libncursesw5-dev with libncurses-dev
  * d/control: replace obsolete B-D on pkg-config with pkgconf
  * d/control: build against newer liblua (liblua5.4)
  * d/rules: drop override_dh_auto_test, made unnecessary by upstream change
  * d/rules: turn override_dh_auto_clean into execute_after_dh_auto_clean
  * d/copyright: update copyright years for debian/*

 -- Paride Legovini <paride@debian.org>  Fri, 10 May 2024 15:58:40 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Build-Depends:
  debhelper-compat (= 13),
  libacl1-dev,
- liblua5.3-dev,
- libncursesw5-dev,
+ liblua5.4-dev,
+ libncurses-dev,
  libselinux1-dev [linux-any],
  libtermkey-dev,
  libtermkey1,
@@ -14,9 +14,9 @@
  locales-all,
  lua-busted,
  lua-lpeg,
- pkg-config,
+ pkgconf,
  vim [amd64 arm64 ppc64el],
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Homepage: https://github.com/martanne/vis
 Vcs-Git: https://salsa.debian.org/debian/vis.git
 Vcs-Browser: https://salsa.debian.org/debian/vis

=== debian/rules ===
--- 
+++ 
@@ -28,10 +28,6 @@
 	#
 	./configure --prefix=/usr
 
-override_dh_auto_test:
-	# https://github.com/martanne/vis-test/issues/25
-	dh_auto_test -- LANG=C.UTF-8
-
 override_dh_auto_install:
 	dh_auto_install -- DOCUMENTATION=README.md
 
@@ -39,9 +35,7 @@
 	rm -v debian/vis/usr/share/vis/lexers/LICENSE
 	rm -v debian/vis/usr/share/vis/lexers/README.md
 
-override_dh_auto_clean:
-	dh_auto_clean
-
+execute_after_dh_auto_clean:
 	# Cleanup the test suite submodule.
 	# Remove if https://github.com/martanne/vis/pull/848 lands.
 	$(MAKE) -C test clean

=== debian/tests/control ===
Depends:
 locales-all,
 lua-lpeg,
 @,
Test-Command: cd test/vis && VIS=vis ./test.sh

=== debian/watch ===
# Only use to report new upstream versions.
# The packaging follows a pure-git workflow (gbp import-ref).

version=4
opts=mode=git https://github.com/martanne/vis.git refs/tags/v@ANY_VERSION@

## vis cpu-0.1.2

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf _autosummary/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/vis_cpu.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/vis_cpu.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/vis_cpu"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/vis_cpu"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."
